/*
 *  stdlib.h    Standard Library functions
 *
 *                          Open Watcom Project
 *
 *    Portions Copyright (c) 1983-2002 Sybase, Inc. All Rights Reserved.
 *  Copyright by QNX Software Systems Limited 1990-1996. All rights reserved.
 */
#ifndef _STDLIB_H_INCLUDED
#define _STDLIB_H_INCLUDED
#ifdef __cplusplus
extern "C" {
#endif

#ifndef _COMDEF_H_INCLUDED
 #include <_comdef.h>
#endif

#if defined(_M_IX86)
  #pragma pack(__push,1);
#else
  #pragma pack(__push,8);
#endif

#ifndef _WCHAR_T_DEFINED
#define _WCHAR_T_DEFINED
#define _WCHAR_T_DEFINED_
#ifdef __cplusplus
typedef long char wchar_t;
#else
typedef unsigned short wchar_t;
#endif
#endif

#ifndef _SIZE_T_DEFINED
#define _SIZE_T_DEFINED
#define _SIZE_T_DEFINED_
typedef unsigned size_t;
#endif

#ifndef _WCHAR_T_DEFINED
#define _WCHAR_T_DEFINED
#define _WCHAR_T_DEFINED_
#ifdef __cplusplus
typedef long char wchar_t;
#else
typedef unsigned short wchar_t;
#endif
#endif
#ifndef NULL
 #if defined(__SMALL__) || defined(__MEDIUM__) || defined(__386__)
  #define NULL   0
 #else
  #define NULL   0L
 #endif
#endif

#ifndef MB_CUR_MAX
    #define MB_CUR_MAX  6
#endif
#ifndef MB_LEN_MAX
    #define MB_LEN_MAX  6
#endif

#ifndef _MAX_PATH
 #define _MAX_PATH      256     /*  maximum length of path name         */
#endif

#define RAND_MAX        32767u
#define EXIT_SUCCESS    0
#define EXIT_FAILURE    1

typedef struct  {
        int     quot;
        int     rem;
} div_t;

typedef struct  {
        long    quot;
        long    rem;
} ldiv_t;

_WCRTLINK extern void    abort( void );
_WCIRTLINK extern int    abs( int __j );
          extern int     atexit( register void ( *__func )( void ) );
_WMRTLINK extern double  atof( const char *__nptr );
_WCRTLINK extern int     atoi( const char *__nptr );
_WCRTLINK extern long int atol( const char *__nptr );
_WCRTLINK extern void   *bsearch( const void *__key, const void *__base,
                                  size_t __nmemb, size_t __size,
                                  int (*__compar)(const void *__pkey,
                                                  const void *__pbase) );
_WCRTLINK extern void    break_on( void );
_WCRTLINK extern void    break_off( void );
_WCRTLINK extern void   *calloc( size_t __n, size_t __size );
_WCIRTLINK extern div_t  div( int __numer, int __denom );
_WCRTLINK extern void    exit( int __status );
_WCRTLINK extern void    free( void *__ptr );
_WCRTLINK extern char   *getenv( const char *__name );
_WCIRTLINK extern long int labs( long int __j );
#if defined(__386__)
_WCIRTLINK
#else
_WCRTLINK
#endif
extern ldiv_t ldiv( long int __numer, long int __denom );
_WCRTLINK extern void   *malloc( size_t __size );
_WCRTLINK extern int     mblen( const char *__s, size_t __n );
_WCRTLINK extern size_t  mbstowcs( wchar_t *__pwcs, const char *__s,
                                   size_t __n );
_WCRTLINK extern int     mbtowc( wchar_t *__pwc, const char *__s, size_t __n );
_WCRTLINK extern size_t  wcstombs( char *__s, const wchar_t *__pwcs,
                                   size_t __n );
_WCRTLINK extern int     wctomb( char *__s, wchar_t __wchar );
_WCRTLINK extern void    qsort( void *__base, size_t __nmemb, size_t __size,
                                int (*__compar)( const void *, const void * ) );
_WCRTLINK extern int     rand( void );
_WCRTLINK extern void   *realloc( void *__ptr, size_t __size );
_WCRTLINK extern void    srand( unsigned int __seed );
_WMRTLINK extern double  strtod( const char *__nptr, char **__endptr );
_WCRTLINK extern long int strtol( const char *__nptr, char **__endptr,
                                 int __base );
_WCRTLINK extern unsigned long strtoul( const char *__nptr, char **__endptr,
                                       int __base );
_WCRTLINK extern int     system( const char *__string );

#if defined(__INLINE_FUNCTIONS__)
 #pragma intrinsic(abs,div,labs)
 #if defined(__386__)
  #pragma intrinsic(ldiv)
 #endif
#endif

#ifndef __cplusplus
#define atof(p)  strtod(p,(char **)NULL)
#endif

#if defined(_POSIX_SOURCE) || defined(_QNX_SOURCE) || !defined(NO_EXT_KEYS)
void             _exit( int __status );
#endif

#if defined(_QNX_SOURCE) || !defined(NO_EXT_KEYS) /*extensions enabled*/

extern unsigned  atoh( const char *__nptr );
_WMRTLINK extern char   *ecvt( double __val, int __ndig, int *__dec,
                               int *__sign );
_WMRTLINK extern char   *_ecvt( double __val, int __ndig, int *__dec,
                               int *__sign );
_WMRTLINK extern char   *fcvt( double __val, int __ndig, int *__dec,
                               int *__sign );
_WMRTLINK extern char   *_fcvt( double __val, int __ndig, int *__dec,
                                int *__sign );
_WCRTLINK extern char   *_fullpath( char *__buf, const char *__path,
                                    size_t __size );
_WMRTLINK extern char   *gcvt( double __val, int __ndig, char *__buf );
_WMRTLINK extern char   *_gcvt( double __val, int __ndig, char *__buf );
_WCRTLINK extern char   *itoa( int __value, char *__buf, int __radix );
_WCRTLINK extern char   *_itoa( int __value, char *__buf, int __radix );
#if defined(__386__)
_WCIRTLINK
#else
_WCRTLINK
#endif
extern unsigned long _lrotl( unsigned long __value, unsigned int __shift );
#if defined(__386__)
_WCIRTLINK
#else
_WCRTLINK
#endif
extern unsigned long _lrotr( unsigned long __value, unsigned int __shift );
_WCRTLINK extern char   *ltoa( long int __value, char *__buf, int __radix );
_WCRTLINK extern char   *_ltoa( long int __value, char *__buf, int __radix );
_WCRTLINK extern void    _makepath( char *__path, const char *__drive,
                                    const char *__dir, const char *__fname,
                                    const char *__ext );
_WCIRTLINK extern unsigned int _rotl( unsigned int __value, unsigned int __shift );
_WCIRTLINK extern unsigned int _rotr( unsigned int __value, unsigned int __shift );

_WMRTLINK extern wchar_t *_wecvt( double __val, int __ndig, int *__dec,
                                  int *__sign );
_WMRTLINK extern wchar_t *_wfcvt( double __val, int __ndig, int *__dec,
                                  int *__sign );
_WMRTLINK extern wchar_t *_wgcvt( double __val, int __ndig, wchar_t *__buf );

_WCRTLINK extern int      _wtoi( const wchar_t * );
_WCRTLINK extern long int _wtol( const wchar_t * );
_WCRTLINK extern wchar_t *_itow( int, wchar_t *, int );
_WCRTLINK extern wchar_t *_ltow( long int, wchar_t *, int );
_WCRTLINK extern wchar_t *_utow( unsigned int, wchar_t *, int );
_WCRTLINK extern wchar_t *_ultow( unsigned long int, wchar_t *, int );

_WMRTLINK extern double  _wtof( const wchar_t * );
_WMRTLINK extern double  _watof( const wchar_t * );
_WCRTLINK extern long int wcstol( const wchar_t *, wchar_t **, int );
_WMRTLINK extern double  wcstod( const wchar_t *, wchar_t ** );
_WCRTLINK extern unsigned long int wcstoul( const wchar_t *, wchar_t **, int );
_WCRTLINK extern wchar_t *_atouni( wchar_t *, const char * );

_WCRTLINK extern wchar_t *_wfullpath( wchar_t *, const wchar_t *, size_t );
_WCRTLINK extern void     _wmakepath( wchar_t *__path, const wchar_t *__drive,
                                      const wchar_t *__dir,
                                      const wchar_t *__fname,
                                      const wchar_t *__ext );

_WCRTLINK extern int _wcsicmp( const wchar_t *, const wchar_t * );
_WCRTLINK extern wchar_t *_wcsdup( const wchar_t * );
_WCRTLINK extern int _wcsnicmp( const wchar_t *, const wchar_t *, size_t );
_WCRTLINK extern wchar_t *_wcslwr( wchar_t * );
_WCRTLINK extern wchar_t *_wcsupr( wchar_t * );
_WCRTLINK extern wchar_t *_wcsrev( wchar_t * );
_WCRTLINK extern wchar_t *_wcsset( wchar_t *, wchar_t );
_WCRTLINK extern wchar_t *_wcsnset( wchar_t *, int, size_t );

_WCRTLINK extern wchar_t *  _wgetenv( const wchar_t *__name );
_WCRTLINK extern int        _wsetenv( const wchar_t *__name,
                                      const wchar_t *__newvalue,
                                      int __overwrite );
_WCRTLINK extern int        _wputenv( const wchar_t *__env_string );


_WCRTLINK extern int     putenv( const char *__string );
_WCRTLINK extern void    _searchenv( const char *__name, const char *__env_var,
                                     char *__buf );
extern int       need_usage( char **argv );
extern int       print_usage( char **argv );
extern void      searchenv( const char *__name, const char *__env_var,
                            char *__buf );
_WCRTLINK extern void    _splitpath2( const char *__inp, char *__outp,
                                      char **__drive, char **__dir,
                                      char **__fn, char **__ext );
_WCRTLINK extern void    _splitpath( const char *__path, char *__drive,
                                     char *__dir, char *__fname, char *__ext );
_WCRTLINK extern void    swab( char *__src, char *__dest, int __num );
_WCRTLINK extern char   *ultoa( unsigned long int __value, char *__buf,
                                int __radix );
_WCRTLINK extern char   *_ultoa( unsigned long int __value, char *__buf,
                                int __radix );
_WCRTLINK extern char   *utoa( unsigned int __value, char *__buf, int __radix );
_WCRTLINK extern char   *_utoa( unsigned int __value, char *__buf, int __radix );

#if defined(__INLINE_FUNCTIONS__)
 #pragma intrinsic(_rotl,_rotr)
 #if defined(__386__)
  #pragma intrinsic(_lrotl,_lrotr)
 #endif
#endif

/* min and max macros */
#if !defined(__max)
#define __max(a,b)  (((a) > (b)) ? (a) : (b))
#endif
#if !defined(max) && !defined(__cplusplus)
#define max(a,b)  (((a) > (b)) ? (a) : (b))
#endif
#if !defined(__min)
#define __min(a,b)  (((a) < (b)) ? (a) : (b))
#endif
#if !defined(min) && !defined(__cplusplus)
#define min(a,b)  (((a) < (b)) ? (a) : (b))
#endif

/*
 * The following sizes are the maximum sizes of buffers used by the _fullpath()
 * _makepath() and _splitpath() functions.  They include space for the '\0'
 * terminator.
 */
#define _MAX_DRIVE      48      /*  maximum length of node name w/ '\0' */
#define _MAX_NODE    _MAX_DRIVE /*  maximum length of node name w/ '\0' */
#define _MAX_DIR        256     /*  maximum length of subdirectory      */
#define _MAX_FNAME      48      /*  maximum length of a file name       */
#define _MAX_EXT        48      /*  maximum length of a file extension  */

#define _MAX_PATH2 (_MAX_PATH+3) /* maximum size of output buffer
                                    for _splitpath2() */

_WCRTLINK extern char **environ;                /*  pointer to environment table */
_WCRTLINK extern wchar_t **_wenviron;   /*  pointer to wide environment */

#ifndef errno
#define errno (*__get_errno_ptr())
#endif
_WCRTLINK extern int errno;
_WCRTLINK extern unsigned _WCDATA      _amblksiz;   /*  mallocs done in multiples of    */
_WCRTLINK extern unsigned char _WCDATA _osmajor;    /*  O/S major version # */
_WCRTLINK extern unsigned char _WCDATA _osminor;    /*  O/S minor version # */
extern  int       __argc;       /* number of cmd line args */
extern  char    **__argv;       /* vector of cmd line args */

#ifndef alloca
 _WCRTLINK extern void  *alloca(size_t __size);
 _WCRTLINK extern void  *_alloca(size_t __size);
 _WCRTLINK extern unsigned stackavail( void );
  extern void  *__doalloca(size_t __size);
  #pragma aux stackavail __modify __nomemory;

  #define __ALLOCA_ALIGN( s )   (((s)+(sizeof(int)-1))&~(sizeof(int)-1))
  #define __alloca( s )         __doalloca(__ALLOCA_ALIGN(s))

   #define alloca( s )  ((__ALLOCA_ALIGN(s)<stackavail())?__alloca(s):NULL)
   #define _alloca( s ) ((__ALLOCA_ALIGN(s)<stackavail())?__alloca(s):NULL)

  #if defined(__386__)
   #pragma aux     __doalloca =              \
            "sub esp,eax"                    \
            __parm __nomemory [__eax] __value [__esp] __modify __exact __nomemory [__esp];
  #elif defined(__SMALL__) || defined(__MEDIUM__) /* small data models */
   #pragma aux __doalloca = \
            "sub sp,ax"     \
            __parm __nomemory [__ax] __value [__sp] __modify __exact __nomemory [__sp];
  #else                                           /* large data models */
   #pragma aux __doalloca = \
            "sub sp,ax"     \
            "mov ax,sp"     \
            "mov dx,ss"     \
            __parm __nomemory [__ax] __value [__dx __ax] __modify __exact __nomemory [__dx __ax __sp];
  #endif
#endif

#if defined(__386__)
_WCRTLINK extern int brk(void *endds);
_WCRTLINK extern void *sbrk(int incr);
#else
_WCRTLINK extern void _WCNEAR *__brk(unsigned __new_brk_value);
_WCRTLINK extern void _WCNEAR *sbrk(int __increment);
#endif

 typedef void (*onexit_t)();
_WCRTLINK extern onexit_t onexit(onexit_t __func);
#endif

#pragma pack(__pop);
#ifdef __cplusplus
};
#endif
#endif
